LENGTH = 3.2;
WIDTH = 1.6;
HEIGHT = 1.3;

CASE_X = LENGTH;
CASE_Y = WIDTH;
CASE_Z = HEIGHT *2/3;
CASE_COLOR = "lightgray";

PAD_X = .5;
PAD_Y = 1.6;
PAD_Z = .02;
PAD_STEP_X = LENGTH - PAD_X;
PAD_STEP_Y = .45 + .5;
PAD_NUM = 2;
PAD_COLOR = "gold";

PAD_CYL_DIAM = .25;

module draw_case(x,y,z,c) {
    color(c) cube([x,y,z], true);
}

module draw_pad(x, y, z, c) {
    color (c) cube([x, y, z], true);
}

module draw_marker(s, d, c) {
    color (c) linear_extrude(d) circle(s/2);
}

module draw_pad_array(x, y, length, width, height, step_x, step_y, color) {
    for(i = [0:x-1]) {
        for(j = [0:y-1]) {
            translate ([i*step_x,j*step_y,0]) draw_pad(length, width, height, color);
        }
    }
}

translate([0,0,CASE_Z/2+PAD_Z]) {// Set model flat on Z axis
    union() {
        // Draw the bottom case
        draw_case(CASE_X, CASE_Y, CASE_Z, CASE_COLOR);
        
        // Draw the pads
        translate([-PAD_STEP_X/2, -(PAD_NUM/2-1)*PAD_STEP_Y/2, -(CASE_Z+PAD_Z)/2])
        draw_pad_array(2, PAD_NUM/2, PAD_X, PAD_Y, PAD_Z, PAD_STEP_X, PAD_STEP_Y, PAD_COLOR);
    }
}