LENGTH = 1.256;
WIDTH = .914;
HEIGHT = .325;
CASE_COLOR = [.15,.15,.15];
PINMARK_COLOR = "gray";
PINMARK_DEPTH = .2;
PINMARK_SIZE = .3;

PAD_SIZE = .3;
PAD_STEP = .4;
PAD_COL = 2;
PAD_LINES = 3;
PAD_COLOR = "gray";

module draw_case(l,w,h,c) {
    color(c) cube([l,w,h], true);
}

module draw_ball(s, c) {
    color(c) sphere(s/2);
}

module draw_marker(s, d, c) {
    color (c) linear_extrude(d) circle(s/2);
}

module draw_pad_array(columns, lines, size, step, color) {
    for(i = [0:columns-1]) {
        for(j = [0:lines-1]) {
            translate ([j*step,i*step,0]) draw_ball(size, color);
        }
    }
}

translate([0,0,HEIGHT/2+PAD_SIZE/2]) {
    draw_case(LENGTH, WIDTH, HEIGHT, CASE_COLOR);
    translate([(LENGTH/2 - PINMARK_SIZE), (WIDTH/2 - PINMARK_SIZE),0])
    draw_marker(PINMARK_SIZE, PINMARK_DEPTH, PINMARK_COLOR);

    translate([-(PAD_LINES-1)*PAD_STEP/2, -(PAD_COL-1)*PAD_STEP/2, -HEIGHT/2])
    draw_pad_array(PAD_COL, PAD_LINES, PAD_SIZE, PAD_STEP, PAD_COLOR);
}