WIDTH = .896;
LENGTH = 1.592;
HEIGHT = .4;
CASE_COLOR = [.15,.15,.15];
PINMARK_COLOR = "gray";
PINMARK_DEPTH = .01;
PINMARK_SIZE = .3;

PAD_SIZE = .25;
PAD_STEP = .4;
PAD_X_NUM = 2;
PAD_Y_NUM = 4;
PAD_COLOR = "gray";

module draw_case(x,y,z,c) {
    color(c) cube([x,y,z], true);
}

module draw_ball(d, c) {
    color(c) sphere(d/2);
}

module draw_marker(d, l, c) {
    color (c) linear_extrude(l) circle(d/2);
}

module draw_pad_array(x, y, size, step, color) {
    for(i = [0:x-1]) { // Create columns
        for(j = [0:y-1]) { // Create lines
            translate ([i*step,j*step,0]) draw_ball(size, color);
        }
    }
}

translate([0,0,HEIGHT/2+PAD_SIZE/2]) { // Set flat on Z axis
    // Draw component casing
    draw_case(WIDTH, LENGTH, HEIGHT, CASE_COLOR);

    // Draw pin 1 marker
    translate([-(WIDTH/2 - PINMARK_SIZE), (LENGTH/2 - PINMARK_SIZE), HEIGHT/2])
    draw_marker(PINMARK_SIZE, PINMARK_DEPTH, PINMARK_COLOR);

    // Draw BGA balls
    translate([-(PAD_X_NUM-1)*PAD_STEP/2, -(PAD_Y_NUM-1)*PAD_STEP/2, -HEIGHT/2])
    draw_pad_array(PAD_X_NUM, PAD_Y_NUM, PAD_SIZE, PAD_STEP, PAD_COLOR);
}