BODY_LENGTH = 2.9;
BODY_DIAM = 1.488;
BODY_COLOR = "silver";

HEAD_LENGTH = 2.457;
HEAD_DIAM = 2.48;
HEAD_COLOR = BODY_COLOR;

O_RING_OFFSET = 3.727;
O_RING_LENGTH = .55;
O_RING_DIAM = 1.9;
O_RING_COLOR = "black";

TIP_LENGTH = .23;
TIP_DIAM = 1.54;
TIP_COLOR = BODY_COLOR;
CONE_LENGTH = 0.44 - TIP_LENGTH;

module draw_cylinder(l, d, c) {
    rotate([0,0,0]) color (c) cylinder(h=l, d=d);
}

translate([0,0,HEAD_LENGTH])
{
    // body
    draw_cylinder(BODY_LENGTH, BODY_DIAM, BODY_COLOR);

    // pad
    translate([0,0,-HEAD_LENGTH])
    draw_cylinder(HEAD_LENGTH, HEAD_DIAM, HEAD_COLOR);

    // o-ring
    translate([0,0,O_RING_OFFSET - HEAD_LENGTH])
    draw_cylinder(O_RING_LENGTH, O_RING_DIAM, O_RING_COLOR);

    // tip+cone
    translate([0,0,BODY_LENGTH])
    color(TIP_COLOR) cylinder(h=TIP_LENGTH, d=TIP_DIAM);
    translate([0,0,BODY_LENGTH+TIP_LENGTH])
    color(TIP_COLOR) cylinder(h=CONE_LENGTH, d1=TIP_DIAM, d2=0);
}