LENGTH = 2;
WIDTH = 1.05;
HEIGHT = .5 - .04;
CASE_COLOR = [.15,.15,.15];
PINMARK_COLOR = "gray";
PINMARK_DEPTH = .05;
PINMARK_SIZE = .3;

PAD_X = .35;
PAD_Y = .25;
PAD_Z = .1;
PAD_Z_OFFSET = .04;
PAD_STEP_X = .6;
PAD_STEP_Y = .5;
PAD_NUM = 8;
PAD_COLOR = "gray";

module draw_case(x,y,z,c) {
    color(c) cube([x,y,z], true);
}

module draw_pad(x, y, z, c) {
    color (c) cube([x, y, z], true);
}

module draw_marker(s, d, c) {
    color (c) linear_extrude(d) circle(s/2);
}

module draw_pad_array(x, y, length, width, height, step_x, step_y, color) {
    for(i = [0:x-1]) {
        for(j = [0:y-1]) {
            translate ([i*step_x,j*step_y,0]) draw_pad(length, width, height, color);
        }
    }
}

translate([0,0,HEIGHT/2]) {// Set model flat on Z axis
    // Draw the case
    draw_case(WIDTH, LENGTH, HEIGHT, CASE_COLOR);

    // Draw the pin 1 marker
    translate([-(WIDTH/2 - PINMARK_SIZE), LENGTH/2 - PINMARK_SIZE, HEIGHT/2-PINMARK_DEPTH/2])
    draw_marker(PINMARK_SIZE, PINMARK_DEPTH, PINMARK_COLOR);

    // Draw the pads
    translate([-PAD_STEP_X/2, -(PAD_NUM/2-1)*PAD_STEP_Y/2, -(HEIGHT-PAD_Z+PAD_Z_OFFSET*2)/2])
    draw_pad_array(2, PAD_NUM/2, PAD_X, PAD_Y, PAD_Z, PAD_STEP_X, PAD_STEP_Y, PAD_COLOR);
}